//dog whistle JTN 20230320

$fa=3;
$fs=0.25;
eps=1/128;

bd = 10;			//base diameter
bl = 36;			//base length
bc = -2;			//bottom cut
rr = 1;				//rounding radius
il = 20;			//inlet length
iw = 6;				//inlet width
ih = 1.1;			//inlet height
io = 2.2;			//inlet offset
my = bd/2-2.25;		// = mouth depth
mz = 20;			//mouth z position
mw = 5.9;			//mouth width
rl = 14;			//resonance cavity length	//abt. 4800 Hz
rw = 6;				//resonance cavity width
rh = 3.5;			//resonance cavity height
ro = io+(ih-rh)/2;	//resonance cavity offset

mt = 3;				//mount thickness
ml = 10;			//mount length
mo = 8;				//carrying strap hole offset
md = 4;				//strap hole diameter
er = 10;			//top edge radius
lt = 1.5;			//bottom lip thickness
ly = 1;				//bottom lip y
lz = 0.5;			//bottom lip z

//p = [[0,0],[0,1],[5,8],[5,0]]; //steeper lip
p = [[0,0],[0,1],[5,10],[5,0]];	// gentler lip

module base_form(h=bl) {
	linear_extrude(height=h,convexity=5) offset(rr) offset(-rr) difference() {
			circle(d=bd);
			translate([0,-(bd/2-bc)]) square(bd,center=true);
	}
	
}

difference() {
	base_form();
	translate([0,io]) linear_extrude(height=il,convexity=5) square([iw,ih],center=true);						//inlet
	translate([0,my,mz]) rotate([90,0,90]) linear_extrude(height=mw,convexity=5,center=true) polygon(p);		//mouth
	translate([0,ro,rl/2+il]) cube([rw,rh,rl],center=true);
	//translate([bd/2,0,bl/2]) cube([bd,bd,bl],center=true);													//partial cut-away
}

difference() {
	union() {
		translate([0,0,bl]) hull() {																			//neck
			base_form(h=eps);
			translate([0,0,mt]) linear_extrude(height=eps,convexity=5) offset(rr) offset(-rr) square([bd,mt],center=true);
		}
		translate([0,0,mt+bl]) intersection() {																	//rounded top
			linear_extrude(height=ml,convexity=5) offset(rr) offset(-rr)square([bd,mt],center=true);
			rotate([90,0,0]) cylinder(h=mt+1,r=er,center=true);
		}
		translate([0,ly,lz]) rotate_extrude(angle=180,convexity=5) translate([bd/2-1,0]) circle(d=lt);			//lip
	}
	translate([0,0,-10]) cube(20,center=true);																	//clean bottom
	translate([0,0,bl+mo]) rotate([90,0,0]) cylinder(h=mt+1,d=md,center=true);
}
		

